#pragma once

#include <vector>
#include <math.h>

inline double CalculateDelay(double state) {
	return pow(state, 2);
}

class DeskListUI : public CTileLayoutUI
{
public:
	enum { SCROLL_TIMERID = 10 };

	DeskListUI() : m_uButtonState(0), m_dwDelayDeltaY(0), m_dwDelayNum(0), m_dwDelayLeft(0)
	{
		SetItemSize(CSize(182, 152));
		CDialogBuilder builder;
		CContainerUI* pDesk = static_cast<CContainerUI*>(builder.Create(_T("desk.xml"), (UINT)0));
		if( pDesk != NULL ) {
			for(int i = 0; i < 500; ++i) 
			{
				if( pDesk == NULL ) pDesk = static_cast<CContainerUI*>(builder.Create());
				if( pDesk != NULL ) {
					this->Add(pDesk);
					TCHAR indexBuffer[16];
					CDuiString strIndexString = _T("- ");
					strIndexString += _itot(i+1, indexBuffer, 10);
					strIndexString += _T(" -");
					pDesk->GetItemAt(3)->SetText(strIndexString);
					pDesk = NULL;
				}
				else {
					this->RemoveAll();
					return;
				}
			}
		}
	}

	void DoEvent(TEventUI& event) 
	{
		if( !IsMouseEnabled() && event.Type > UIEVENT__MOUSEBEGIN && event.Type < UIEVENT__MOUSEEND ) {
			if( m_pParent != NULL ) m_pParent->DoEvent(event);
			else CTileLayoutUI::DoEvent(event);
			return;
		}
		
		if( event.Type == UIEVENT_SCROLLWHEEL )
		{
			LONG lDeltaY = 0;
			if( m_dwDelayNum > 0 ) lDeltaY =  (LONG)(CalculateDelay((double)m_dwDelayLeft / m_dwDelayNum) * m_dwDelayDeltaY);
			switch( LOWORD(event.wParam) ) {
case SB_LINEUP:
	if( m_dwDelayDeltaY >= 0 ) m_dwDelayDeltaY = lDeltaY + 8;
	else m_dwDelayDeltaY = lDeltaY + 12;
	break;
case SB_LINEDOWN:
	if( m_dwDelayDeltaY <= 0 ) m_dwDelayDeltaY = lDeltaY - 8;
	else m_dwDelayDeltaY = lDeltaY - 12;
	break;
			}
			if( m_dwDelayDeltaY > 100 ) m_dwDelayDeltaY = 100;
			else if( m_dwDelayDeltaY < -100 ) m_dwDelayDeltaY = -100;
			m_dwDelayNum = (DWORD)sqrt((double)abs(m_dwDelayDeltaY)) * 5;
			m_dwDelayLeft = m_dwDelayNum;
			m_pManager->SetTimer(this, SCROLL_TIMERID, 50U);
			return;
		}
		CTileLayoutUI::DoEvent(event);
	}

private:
	UINT m_uButtonState;
	POINT m_ptLastMouse;
	LONG m_dwDelayDeltaY;
	DWORD m_dwDelayNum;
	DWORD m_dwDelayLeft;
};

